#include <iostream>

typedef           unsigned uint32;
typedef long long unsigned uint64;

static uint64 rdtsc(void) {
    uint32 low, high;

    __asm__ __volatile__ ("rdtsc" : "=a" (low), "=d" (high));
    return low | (uint64(high) << 32);
}

int main(int, char *[]) {
    uint64 previous = 0, current, initial = rdtsc();
    for (unsigned i = 0;  i < 100 * 1000 * 1000;  ++i) {
        current = rdtsc();
        if (current < previous) {
            std::cout << "After " << i << " iterations:\n"
                         "Current:  " << current  << " (" << std::hex << current  << std::dec << ")\n"
                         "Previous: " << previous << " (" << std::hex << previous << std::dec << ")\n";
            return 1;
        }

        previous = current;
    }

    std::cout << "OK\nOn the final iteration:\n"
                 "Initial:  " << initial << " (" << std::hex << initial << std::dec << ")\n"
                 "Current:  " << current << " (" << std::hex << current << std::dec << ")\n";
    return 0;
}
